// Generated by CoffeeScript 1.8.0
(function() {
  'use strict';
  var commands, program,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  program = require('commander');

  commands = require('./');

  program.version(require('../package.json').version).usage('[command] [options]');

  program.command('new [skeleton] [path]').description('Create new brunch project in path [.]. Short-cut: n').action(function() {
    return commands["new"](program.args[0], program.args[1]);
  });

  program.command('build').description('Build a brunch project. Short-cut: b').option('-e, --env [setting]', 'specify a set of override settings to apply').option('-P, --production', 'same as `--env production`').option('-d, --debug', 'print verbose debug output to stdout').option('-c, --config [path]', '[DEPRECATED] path to config files').option('-o, --optimize', '[DEPRECATED] same as `--env production`').action(commands.build);

  program.command('watch').description('Watch brunch directory and rebuild if something changed. Short-cut: w').option('-e, --env [setting]', 'specify a set of override settings to apply').option('-P, --production', 'same as `--env production`').option('-s, --server', 'run a simple http server that would serve public dir').option('-p, --port [port]', 'if a `server` option was specified, define on which port the server would run').option('-d, --debug', 'print verbose debug output to stdout').option('-c, --config [path]', '[DEPRECATED] path to config files').option('-o, --optimize', '[DEPRECATED] same as `--env production`').action(commands.watch);

  exports.run = function() {
    var args, command, fullCommand;
    args = process.argv.slice();
    command = args[2];
    if (command === 'g' || command === 'd' || command === 'generate' || command === 'destroy') {
      console.error('`brunch generate / destroy` command was removed.\n\nUse scaffolt (https://github.com/paulmillr/scaffolt)\nsuccessor or similar:\n    npm install -g scaffolt\n    scaffolt <type> <name> [options]\n    scaffolt <type> <name> [options] --revert');
    }
    if (command === 't' || command === 'test') {
      console.error('`brunch test` command was removed.\n\nUse mocha-phantomjs (http://metaskills.net/mocha-phantomjs/)\nsuccessor or similar:\n    npm install -g mocha-phantomjs\n    mocha-phantomjs [options] <your-html-file-or-url>');
    }
    if ((command === 'n' || command === 'new') && __indexOf.call(args, '--skeleton') >= 0) {
      return console.error('`--skeleton` option has been removed from `brunch new`.\n\nThe syntax is now simply:\n\nbrunch new <path-or-URI> [optional-output-dir]\nbrunch new github:brunch/dead-simple\nbrunch new gh:paulmillr/brunch-with-chaplin');
    }
    fullCommand = (function() {
      switch (command) {
        case 'n':
          return 'new';
        case 'b':
          return 'build';
        case 'w':
          return 'watch';
        default:
          return command;
      }
    })();
    if (fullCommand != null) {
      args[2] = fullCommand;
    }
    program.parse(args);
    if (fullCommand == null) {
      return program.help();
    }
  };

}).call(this);
